#include<iostream>
#include<cstring>
#include<vector>

using namespace std;

const int MAXN = 25;
const long long mod = 1e9 + 7;

int n, m;
int u, v;

int answer = 0;
vector <int> revGraph[MAXN];

bool used[MAXN];
long long memo[1000005][MAXN];

long long bruteForce(int pos)
{
    if(pos==n)
    {
        return 1;
    }

    int mask = 0;
    for(int i = 1;i<=n;i++)
    {
        mask = mask*2 + used[i];
    }
    if(memo[mask][pos]!=-1) return memo[mask][pos];

    long long answer = 0;
    for(int i = 1;i<=n;i++)
    {
        if(used[i]==false)
        {
            bool fail = false;
            for(int j = 0;j<revGraph[i].size();j++)
            {
                if(used[ revGraph[i][j] ]==false)
                {
                    fail = true;
                    break;
                }
            }

            if(fail==false)
            {
                used[i] = true;
                answer += bruteForce(pos+1);
                used[i] = false;
            }
        }
    }

    memo[mask][pos] = answer%mod;
    return answer;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n >> m;
    for(int i = 0;i<m;i++)
    {
        cin >> u >> v;

        revGraph[v].push_back(u);
    }

    memset(memo, -1, sizeof(memo));
    cout << bruteForce(0) << '\n';
}
