#include<iostream>
#include<cstring>
#include<iomanip>
#include<vector>
#include<algorithm>

using namespace std;

const int MAXN = 5005;

int n, m;
pair <int, int> children[MAXN];

double memo[MAXN][MAXN];
bool calculated[MAXN][MAXN];

double calcState(int x, int leaves)
{
    if(children[x].first==-1)
    {
        if(leaves>0) return 1;
        return 0;
    }
    if(calculated[x][leaves]==true) return memo[x][leaves];
    if(leaves==0) return 0;

    double answer = 0;
    for(int i = 0;i<=leaves;i++)
    {
        double L = calcState(children[x].first, i);
        double R = calcState(children[x].second, leaves-i);

        if(L<R) swap(L, R);
        answer = max(answer, L*(2.0/3.0) + R*(1.0/3.0));

        L = calcState(children[x].first, leaves-i);
        R = calcState(children[x].second, i);

        if(L<R) swap(L, R);
        answer = max(answer, L*(2.0/3.0) + R*(1.0/3.0));
    }

    memo[x][leaves] = answer;
    calculated[x][leaves] = true;

    return answer;
}

double answer = 0;
vector <double> v;

int treeSize[MAXN];

void DFS(int x, double chance)
{
    if(children[x].first==-1)
    {
        treeSize[x] = 1;

        v.push_back(chance);
        return;
    }

    DFS(children[x].first, chance*(2.0/3.0));
    DFS(children[x].second, chance*(1.0/3.0));

    treeSize[x] = treeSize[ children[x].first ] + treeSize[ children[x].second ];
}

bool checkSpecial()
{
    for(int i = 1;i<=n;i++)
    {
        if(children[i].first==-1) continue;
        if(treeSize[ children[i].first ] != treeSize[ children[i].second ] )
        {
            return false;
        }
    }

    return true;
}

void specialSolve()
{
    sort(v.begin(), v.end());
    reverse(v.begin(), v.end());
    for(int i = 0;i<m;i++)
    {
        answer += v[i];
    }

    cout << fixed << setprecision(8) << answer << '\n';
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n >> m;
    for(int i = 1;i<=n;i++)
    {
        cin >> children[i].first;
        if(children[i].first!=-1) cin >> children[i].second;
    }
    DFS(1, 1);

    if(checkSpecial()==true)
    {
        specialSolve();
        return 0;
    }

    memset(calculated, false, sizeof(calculated));
    cout << fixed << setprecision(8) << calcState(1, m) << '\n';
}
