#include<iostream>
#include<cstring>
#include<iomanip>

using namespace std;

const int MAXN = 5005;

int n, m;
pair <int, int> children[MAXN];

double memo[MAXN][MAXN];
bool calculated[MAXN][MAXN];

double calcState(int x, int leaves)
{
    if(children[x].first==-1)
    {
        if(leaves>0) return 1;
        return 0;
    }
    if(calculated[x][leaves]==true) return memo[x][leaves];
    if(leaves==0) return 0;

    double answer = 0;
    for(int i = 0;i<=leaves;i++)
    {
        double L = calcState(children[x].first, i);
        double R = calcState(children[x].second, leaves-i);

        if(L<R) swap(L, R);
        answer = max(answer, L*(2.0/3.0) + R*(1.0/3.0));

        if(n>100) break;
    }

    memo[x][leaves] = answer;
    calculated[x][leaves] = true;

    return answer;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n >> m;
    for(int i = 1;i<=n;i++)
    {
        cin >> children[i].first;
        if(children[i].first!=-1) cin >> children[i].second;
    }

    memset(calculated, false, sizeof(calculated));
    cout << fixed << setprecision(8) << calcState(1, m) << '\n';
}
