#include<iostream>
#include<cstdio>
#include<algorithm>
#include<vector>
#include<iomanip>
using namespace std;

struct node
{
    int parent = -1;
    int l = -1, r = -1;
    bool listo = false;
    int layer=-1;
} nodes[5001];

bool decisions[5001];
int depths[5001];
int nums[5001];
double prob[5001];

int n, t;

vector<double> probAnswer;

void setLayers(int cur, int layer)
{
    nodes[cur].layer = layer;
    if (!nodes[cur].listo)
    {
        setLayers(nodes[cur].l, layer+1);
        setLayers(nodes[cur].r, layer+1);
    }
}

void setProbability(int cur)
{
    if (prob[cur] == false)
    {
        prob[nodes[cur].l] = prob[cur]*(0.66666666666666);
        prob[nodes[cur].r] = prob[cur]*(0.33333333333333);
    }
    else
    {
        prob[nodes[cur].l] = prob[cur]*(0.33333333333333);
        prob[nodes[cur].r] = prob[cur]*(0.66666666666666);
    }
    if (nodes[nodes[cur].l].listo == false) setProbability(nodes[cur].l);
    else probAnswer.push_back(prob[nodes[cur].l]);
    if (nodes[nodes[cur].r].listo == false) setProbability(nodes[cur].r);
    else probAnswer.push_back(prob[nodes[cur].r]);
}

bool sortByTopLayer(int a, int b)
{
    if (nodes[a].layer > nodes[b].layer) return true;
    else if (nodes[a].layer < nodes[b].layer) return false;
    else return a < b;
}

int main ()
{
    scanf("%d%d", &n, &t);
    for (int i=1; i<=n; i++)
    {
        nums[i] = i;
        int a,b;
        scanf("%d", &a);
        if (a == -1)
        {
            nodes[i].listo = true;
        }
        else
        {
            scanf("%d", &b);
            nodes[i].l = a;
            nodes[i].r = b;
            nodes[a].parent = i;
            nodes[b].parent = i;
        }
    }
    setLayers(1, 0);

    sort(nums+1, nums+n+1, sortByTopLayer);

    for (int i=1; i<=n; i++)
    {
        int cur = nums[i];
        if (nodes[cur].listo == true) continue;

        if (depths[nodes[cur].l] > depths[nodes[cur].r])
        {
            decisions[cur] = true;
            depths[cur] = depths[nodes[cur].r] + 1;
        }
        else
        {
            decisions[cur] = false;
            depths[cur] = depths[nodes[cur].l] + 1;
        }
    }

    prob[1] = 1;
    setProbability(1);

    sort(probAnswer.begin(), probAnswer.end());

    double ans=0;
    int sz = probAnswer.size();
    for (int i=sz-1; sz-1-i < t; i--)
    {
        ans = ans + probAnswer[i];
    }
    cout<<setprecision(8)<<ans<<endl;

    return 0;
}
/**
15 4
2 3
4 5
6 7
8 9
10 11
12 13
14 15
-1
-1
-1
-1
-1
-1
-1
-1

7 2
2 3
4 5
-1
-1
6 7
-1
-1

*/
