#include<iostream>
#include<vector>
using namespace std;

struct node
{
    node * parent;
    node * left = nullptr;
    node * right = nullptr;
    node * mid = nullptr;
    int val=-1, len=0;
    bool root = false;

    node() {this->left = nullptr; this->right = nullptr, this->mid = nullptr, this->val = -1, this->len = 0; this->root = false; this->parent = nullptr;}
    node(int val, int len)
    {
        *this = node();
        this->val = val;
        this->len = len;
    }

} root;

int n,t, sz;
vector<pair<int, int> > f;
vector<int> sums;

void initRoot(int biggest2, int cur, node* parent)
{
    parent->mid = nullptr;
    if (cur < biggest2)
    {
        node* leftChild = static_cast<node*>(malloc(sizeof(node)));
        node* rightChild = static_cast<node*>(malloc(sizeof(node)));
        parent->left = leftChild;
        parent->right = rightChild;
        leftChild->parent = parent;
        rightChild->parent = parent;
        leftChild->len = sums[cur*2];
        rightChild->len = sums[cur*2+1];
        leftChild->val = -1;
        rightChild->val = -1;
        initRoot(biggest2, cur*2, leftChild);
        initRoot(biggest2, cur*2+1, rightChild);
    }
    else
    {
        parent->len = sums[cur];
        parent->val = f[cur-biggest2].first;
        parent->left = nullptr;
        parent->right = nullptr;
    }
}

void createTree()
{
    int biggest2=1;
    while (biggest2 < f.size()) biggest2*=2;
    f.resize(biggest2, make_pair(-1, 0));
    sums.resize(biggest2*2);
    for (int i=biggest2*2-1; i>=biggest2/2; i--)
    {
        sums[i] = f[i-biggest2].second;
    }
    for (int i=biggest2-1; i>=1; i--)
    {
        sums[i] = sums[2*i] + sums[2*i+1];
    }
    root.root = true;
    root.val = -1;
    root.len = n;
    initRoot(biggest2, 1, &root);
}

void outputVals(node* cur)
{
    cout<<cur->len<<" "<<cur->val<<endl;
    if (cur->left != nullptr) outputVals(cur->left);
    if (cur->right != nullptr) outputVals(cur->right);
    if (cur->mid != nullptr) outputVals(cur->mid);
}

pair<node*, int> findNode(int k)
{
    int offset = 0;
    node* cur = &root;
    while(cur->left != nullptr && cur->val == -1)
    {
        if (offset < k && k <= offset + cur->left->len)
        {
            cur = cur->left;
        }
        else
        {
            offset+=cur->left->len;
            if (cur->mid != nullptr)
            {
                if (offset < k && k <= offset + cur->mid->len)
                {
                    cur = cur->mid;
                }
                else
                {
                    offset+=cur->mid->len;
                    cur = cur->right;
                }
            }
            else
            {
                cur = cur->right;
            }
        }
    }
    return make_pair(cur, offset);
}

int main ()
{
    scanf("%d", &n);
    for (int i=0; i<n; i++)
    {
        int a;
        scanf("%d", &a);
        if (i == 0)
        {
            f.emplace_back(a, 1);
        }
        else
        {
            if (a != f[f.size()-1].first)
            {
                f.emplace_back(a, 1);
            }
            else
            {
                f[f.size()-1].second++;
            }
        }
    }
    sz = f.size();
    createTree();
    //outputVals(&root);

    scanf("%d", &t);

    for (int i=0; i<t; i++)
    {
        int query;
        scanf("%d", &query);
        if (query == 4)
        {
            outputVals(&root);
            cout<<sz<<endl;
        }
        else if (query == 3)
        {
            int a, b; /// kude, kakvo
            scanf("%d%d", &a, &b);
            pair<node*, int> cur = findNode(a);

            if (b == cur.first->val) continue;

            if (a == cur.second + 1)
            {
                if (cur.first->len == 1) sz--;

                node* leftChild = static_cast<node*>(malloc(sizeof(node)));
                node* rightChild = static_cast<node*>(malloc(sizeof(node)));
                cur.first->left = leftChild;
                cur.first->right = rightChild;

                *(cur.first->left) = node(b, 1);
                *(cur.first->right) = node(cur.first->val, cur.first->len - 1);

                sz++;

                if (a != 1)
                {
                    if (findNode(a-1).first->val == b) sz--;
                }
                if (a != n)
                {
                    if (findNode(a+1).first->val == b) sz--;
                }

                cur.first->val = -1;
            }
            else if (a == cur.second + cur.first->len)
            {
                if (cur.first->len == 1) sz--;

                node* leftChild = static_cast<node*>(malloc(sizeof(node)));
                node* rightChild = static_cast<node*>(malloc(sizeof(node)));
                cur.first->left = leftChild;
                cur.first->right = rightChild;

                *(cur.first->left) = node(cur.first->val, cur.first->len - 1);
                *(cur.first->right) = node(b, 1);

                sz++;
                if (a != 1)
                {
                    if (findNode(a-1).first->val == b) sz--;
                }
                if (a != n)
                {
                    if (findNode(a+1).first->val == b) sz--;
                }

                cur.first->val = -1;
            }
            else
            {
                node* leftChild = static_cast<node*>(malloc(sizeof(node)));
                node* rightChild = static_cast<node*>(malloc(sizeof(node)));
                node* midChild = static_cast<node*>(malloc(sizeof(node)));
                cur.first->left = leftChild;
                cur.first->right = rightChild;
                cur.first->mid = midChild;
                *(cur.first->left) = node(cur.first->val, a - cur.second - 1);
                *(cur.first->right) = node(cur.first->val, cur.second + cur.first->len - a);
                *(cur.first->mid) = node(b, 1);
                sz += 2;
                cur.first->val = -1;
            }
        }
    }
}
/**
10
2 3 3 1 1 4 5 1 1 3
8
1 6
3 6 1
4
1 1
2 2 1
4
2 9 2
4
*/
