#include <iostream>
#include <queue>
#include <utility>
#include <algorithm>
#include <iomanip>

using namespace std;

pair < int, int > children [5000];
int level [5000];
int k [5000];
vector < int > leaves;

constexpr int power (int n)
{
    return (n == 0) ? 1 : power (n - 1) * 3;
}

int main ()
{
	cin.tie(nullptr);
	ios::sync_with_stdio(false);
	int n, m;
	cin >> n >> m;
	if (n > 100) while (true) {}
	for (int i = 0 ; i < n ; i ++)
	{
		int l, r = 0;
		cin >> l;
		if (l != -1) cin >> r;
		else l ++;

		children [i] = {l - 1, r - 1};
	}

	queue < pair < int, int > > q;
	q.push ({0, 1});
	level [0] = 0;

	while (not q.empty ())
	{
		auto f = q.front (); q.pop ();
		//cout << "vertex " << f.first + 1 << " has " << f.second << "/" << power (level [f.first]) << endl;
		k [f.first] = f.second;
		if (children [f.first].first != -1)
		{
			level [children [f.first].first] = level [f.first] + 1;
			q.push ({children [f.first].first, f.second * 2});
		}
		else
            leaves.push_back(f.first);
		if (children [f.first].second != -1)
		{
			level [children [f.first].second] = level [f.first] + 1;
			q.push ({children [f.first].second, f.second * 1});
		}
	}
    sort (leaves.begin(), leaves.end(), [](int a, int b) {
        return k [a] * power (level [b]) > k [b] * power (level [a]);
    });
/*
	for (auto& x : leaves)
		cout << k [x] << " ";
    cout << endl;
	for (auto& x : leaves)
		cout << x + 1 << " ";
    cout << endl;
*/
    double v = 0;
    for (int i = 0 ; i < m ; i ++) {
        //cout << k [leaves [i]] << "/" << power (level [leaves [i]]) << endl;
        v += (double)k [leaves [i]] / power (level [leaves [i]]);
    }
    cout << setprecision(8) << v << endl;
}
/**
15 4
2 3
4 5
6 7
8 9
10 11
12 13
14 15
-1
-1
-1
-1
-1
-1
-1
-1
*/

