#include <iostream>
#include <queue>
#include <utility>
#include <algorithm>
#include <iomanip>
#include <cmath>

using namespace std;

const double LOG2CONST = log2(3);

int m;
pair < int, int > children [5000];
//int level [5000];
pair <int, int> k [5000];
vector < int > leaves;

void dfs (int v, int left, int level)
{
    //cout << v << " 2^" << left << "/" << "3^" << level << endl;
    if (children [v].first == -1 and children [v].second == -1)
    {
        k [v] = {left, level};
        return;
    }
    dfs (children [v].first, left + 1, level + 1);
    dfs (children [v].second, left, level + 1);
}

double calc (int left, int level)
{
    double ans = 1;
    for (int i = 0, j = 0 ; i < left or j < level ; )
    {
        if (i < left)
        {
            i ++;
            ans *= 2;
        }
        if (j < level)
        {
            j ++;
            ans /= 3;
        }
    }
    return ans;
}

int main ()
{
	cin.tie(nullptr);
	ios::sync_with_stdio(false);
	int n;
	cin >> n >> m;
	//if (n > 100) while (true) {}
	for (int i = 0 ; i < n ; i ++)
	{
		int l, r = 0;
		cin >> l;
		if (l != -1) cin >> r;
		else
		{
		    leaves.push_back (i);
            l ++;
		}

		children [i] = {l - 1, r - 1};
	}

	/*queue < pair < int, double > > q;
	q.push ({0, 1});
	//level [0] = 0;

	while (not q.empty ())
	{
		auto f = q.front (); q.pop ();
		//cout << "vertex " << f.first + 1 << " has " << f.second << "/" << power (level [f.first]) << endl;
		k [f.first] = f.second;
		if (children [f.first].first != -1)
		{
			//level [children [f.first].first] = level [f.first] + 1;
			q.push ({children [f.first].first, f.second * 2.0 / 3.0});
		}
		if (children [f.first].second != -1)
		{
			//level [children [f.first].second] = level [f.first] + 1;
			q.push ({children [f.first].second, f.second * 1.0 / 3.0});
		}
	}
    */

    dfs (0, 0, 0);

    sort (leaves.begin(), leaves.end(), [](int a, int b) {
        return (k [a].first - k [b].first) > LOG2CONST * (k [a].second - k [b].second);
    });
/*
	for (auto& x : leaves)
		cout << calc(k [x].first, k[x].second) << " ";
    cout << endl;
	for (auto& x : leaves)
		cout << x + 1 << " ";
    cout << endl;
*/
    /*
    */
    double v = 0;
    for (int i = 0 ; i < m ; i ++)
    {
        //cout << k [leaves [i]] << "/" << power (level [leaves [i]]) << endl;
        v += calc (k [leaves [i]].first, k [leaves [i]].second);
    }
    cout << setprecision(8) << v << endl;
}
/**
15 4
2 3
4 5
6 7
8 9
10 11
12 13
14 15
-1
-1
-1
-1
-1
-1
-1
-1
9 2
2 3
4 5
6 7
8 9
-1 -1 -1
-1 -1
*/

