#include <bits/stdc++.h>

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;
template<class T, class T1> inline bool chkmax(T &x, const T1 &y) { return x < y ? x = y, true : false; }
template<class T, class T1> inline bool chkmin(T &x, const T1 &y) { return x > y ? x = y, true : false; }

const int MAXN = 5001;

struct node {
    int parent;
    bool type; /// false - left , true - right

    node() {
        this->parent = -1;
    }
};

int n, m;
node tree[MAXN];
int dout[MAXN];
vector<int> leaves;

void read() {
    cin >> n >> m;
    memset(dout, 0, sizeof(dout));
    for (int i = 1; i <= n; i++) {
        int x, y;
        cin >> x;
        if (x == -1) leaves.push_back(i);
        else {
            cin >> y;
            tree[x].parent = i;
            tree[x].type = false;
            tree[y].parent = i;
            tree[y].type = true;
        }
    }
}

double cost[2] = {2.0 / 3.0, 1.0 / 3.0};

double get_chance(int leaf) {
    double chance = 1.0;
    int node = leaf;
    while (tree[node].parent != -1) {
        chance *= cost[tree[node].type];
        node = tree[node].parent;
    }
    return chance;
}

int popcout(int x) {
    int ans = 0;
    while (x) {
        ans++;
        x -= (x & (-x));
    }
    return ans;
}

void solve() {
    double ans = 0.0;
    for (int mask = 1; mask < (1 << leaves.size()); mask++) {
        if (popcout(mask) != m) continue;
        double curr = 0.0;
        for (int rmask = mask, idx = 0; rmask; rmask >>= 1, idx++) {
            if (rmask & 1) curr += get_chance(leaves[idx]);
        }
        chkmax(ans, curr);
    }
    cout << setprecision(8) << fixed << ans << endl;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();

    return EXIT_SUCCESS;
}
