#include <cstdio>
#include <vector>
#include <algorithm>

using namespace std;

const int MAXN = 1e3 * 5;
const double val[] = {1.00*2/3, 1.00*1/3};

struct ans
{
    double sbor;
    ans(double _sbor)
    {
        sbor = _sbor;
    }

    bool operator<(ans other) const
    {
        return sbor > other.sbor;
    }
};

int n, k;
vector <int> graph[MAXN];
vector <ans> ve;

void read_input()
{
    scanf("%d %d", &n, &k);

    int v, w;
    for(int i = 1; i <= n; i++)
    {
        scanf("%d", &v);
        if(v == -1) continue;
        scanf("%d", &w);
        graph[i].push_back(v);
        graph[i].push_back(w);
    }
}

int maxH;

void dfs2(int v, int depth)
{
    if(graph[v].size() == 0)
    {
        maxH = max(maxH, depth);
    }
    else
    {
        int first = graph[v][0];
        int second = graph[v][1];
        dfs2(first, depth + 1);
        dfs2(second, depth + 1);
    }

}

void dfs(int v, int index, int mask, double sbor)
{
    if(graph[v].size() == 0)
    {
        //printf("%d %.8f\n", v, sbor);
        ve.push_back(ans(sbor));
    }
    else
    {
        int first = graph[v][0];
        int second = graph[v][1];
        int temp = (mask & (1 << index)) == 0? 0 : 1;
        dfs(first, index + 1, mask, sbor * val[temp]);
        dfs(second, index + 1, mask, sbor * val[temp ^ 1]);
    }
}

void solve()
{
    double ansr = 0;
    dfs2(1, 0);
    //printf("%d\n", maxH);
    for(int mask = (1 << maxH) - 1; mask >= 0; mask--)
    {
        ve.clear();
        dfs(1, 0, mask, 1);
        sort(ve.begin(), ve.end());
        double temp = 0;
        for(int i = 0; i < k; i++)
        {
            temp += ve[i].sbor;
        }
        ansr = max(ansr, temp);
    }
    printf("%.8f\n", ansr);
}

int main()
{
    read_input();
    solve();

    return 0;
}

/*
15 4
2 3
4 5
6 7
8 9
10 11
12 13
14 15
-1
-1
-1
-1
-1
-1
-1
-1
*/

/*
7 2
2 3
4 5
-1
6 7
-1
-1
-1
*/
