#include <cstdio>
#include <vector>
#include <map>

using namespace std;

const int MAXN = 1e5 + 5;
const int MOD = 1e9 + 7;

struct sol
{
    int len, prev, br;

    sol(int _len, int _prev, int _br)
    {
        len = _len; prev = _prev; br = _br;
    }

    bool operator<(sol other) const
    {
        return len < other.len || (len == other.len && prev < other.prev) || (len == other.len && prev == other.prev && br < other.br);
    }
};

int n, m;
vector <int> graph[MAXN];
int parents[MAXN];
//int fact[MAXN];
//int T[MAXN][MAXN][MAXN];
map <sol, int> mp;

int add(int f, int s)
{
    f += s;
    if(f >= MOD) f %= MOD;
    return f;
}

int mul(int f, int s)
{
    long long temp = 1LL * f * s;
    if(temp >= MOD) temp %= MOD;
    return temp;
}

int rec(int len, int prev, int br)
{
    if(len == 0)
    {
        return 1;
    }
    if(mp[sol(len, prev, br)])
    {
        return mp[sol(len, prev, br)];
    }
    int ans = 0;
    for(int i = prev; i <= br; i++)
    {
        ans = add(ans, rec(len - 1, i, br));
    }
    return mp[sol(len, prev, br)] = ans;
}

void read_input()
{
    scanf("%d %d", &n, &m);

    int v, w;
    for(int i = 0; i < m; i++)
    {
        scanf("%d %d", &v, &w);
        graph[v].push_back(w);
        parents[w]++;
    }
    /*fact[0] = 1;
    for(int i = 1; i <= n + 1; i++)
    {
        fact[i] = fact[i - 1] * i;
    }*/
}
bool visited[MAXN];

pair <int, int> dfs(int v)
{
    visited[v] = true;
    int z = graph[v].size();
    int cnt = 0;
    int ans = 1;
    //printf("~%d\n",v);

    for(int i = 0; i < z; i++)
    {
        int to = graph[v][i];
        parents[to]--;
    }
    for(int i = 0; i < z; i++)
    {
        int to = graph[v][i];
        if(parents[to] == 0 && !visited[to])
        {
            auto res = dfs(to);
            int ans2 = res.second;
            ans = mul(ans, mul(ans2, rec(res.first, 1, cnt + 1)));
            //ans = ans * ans2 * rec(res.first, 1, cnt + 1);
            //printf("%d %d\n", res.first, cnt + 1);
            cnt += res.first;
        }
    }
    //printf("%d %d\n", v, ans);
    cnt++;
    return {cnt, ans};
}


void solve()
{
    int ans = 1;
    int cnt = 0;
    //printf("%d\n", rec(2, 1, 3));
    for(int i = 1; i <= n; i++)
    {
        if(parents[i] == 0 && !visited[i])
        {
            //printf("%d\n", i);
            //printf("DSA");
            auto res = dfs(i);
            //printf("%d\n", res.second);
            ans = mul(mul(ans, res.second), rec(res.first, 1, cnt + 1));
            //ans = ans * res.second * rec(res.first, 1, cnt + 1);
            cnt += res.first;
        }
    }
    printf("%d\n", ans);
}

int main()
{
    read_input();
    solve();

    return 0;
}

/*
6 7
1 2
1 3
2 3
3 4
2 4
3 5
2 6
*/

/*
4 2
1 2
3 4
*/
