#include <cstdio>
#include <vector>
#include <algorithm>

using namespace std;

const int MAXN = 1e3 * 5;
const double val[] = {1.00*2/3, 1.00*1/3};

struct ans
{
    double sbor;
    ans(double _sbor)
    {
        sbor = _sbor;
    }

    bool operator<(ans other) const
    {
        return sbor > other.sbor;
    }
};

int n, k;
vector <int> graph[MAXN];
vector <ans> ve;

void read_input()
{
    scanf("%d %d", &n, &k);

    int v, w;
    for(int i = 1; i <= n; i++)
    {
        scanf("%d", &v);
        if(v == -1) continue;
        scanf("%d", &w);
        graph[i].push_back(v);
        graph[i].push_back(w);
    }
}

void dfs(int v, double sbor)
{
    if(graph[v].size() == 0)
    {
        ve.push_back(ans(sbor));
    }
    else
    {
        int first = graph[v][0];
        int second = graph[v][1];
        dfs(first, sbor * val[0]);
        dfs(second, sbor * val[1]);
    }
}

void solve()
{
    dfs(1, 1);
    sort(ve.begin(), ve.end());
    double ansr = 0;
    for(int i = 0; i < k; i++)
    {
        ansr += ve[i].sbor;
    }
    printf("%.8f\n", ansr);
}

int main()
{
    read_input();
    solve();

    return 0;
}

/*
15 4
2 3
4 5
6 7
8 9
10 11
12 13
14 15
-1
-1
-1
-1
-1
-1
-1
-1
*/
