#include <iostream>
#include <utility>
#include <cmath>
#include <string>
#include <algorithm>
using namespace std;

const int MAXN=5004;

struct Node
{
    int parent;
    int left, right;
    int depth;
};
Node T[MAXN];

int n, m, maxd=-1;
pair <int ,int> chance[MAXN];
bool bal;
string prob="";

bool cmp (pair <int, int> A, pair <int, int> B)
{
    if (A.first!=A.second) return A.first>A.second;
    return B.first>B.second;
}

void Init ()
{
    cin>>n>>m;
    T[1].depth=0;
    for (int i=1; i<=n; i++)
    {
        int l;
        cin>>l;
        if (l==-1)
        {
            T[i].left=-1;
            T[i].right=-1;
        }
        else
        {
            int r;
            cin>>r;
            T[i].left=l;
            T[i].right=r;
            T[l].parent=i;
            T[r].parent=i;
        }
    }
    for (int i=2; i<=n; i++)
    {
        T[i].depth=T[T[i].parent].depth+1;
        maxd=max (maxd, T[i].depth);
    }
    if (1<<(maxd+1)==n+1) bal=true;
    else bal=false;
}

void Rec (int i, bool is_left, int lf, int rg)
{
    if (T[i].left==-1)
    {
        if (is_left)
        {
            chance[i].first=lf;
            chance[i].second=rg;
        }
        else
        {
            chance[i].first=lf;
            chance[i].second=rg;
        }
        return;
    }
    Rec (T[i].left, true, lf+1, rg);
    Rec (T[i].right, false, lf, rg+1);
}

int main ()
{
    Init ();
    if (m==0) cout<<0<<endl;
    else if (n==1) cout<<1<<endl;
    else
    {
        if (bal)
        {
            Rec (1, false, 0, 0);
            sort (chance, chance+n, cmp);
            double num=0;
            double denom=pow(3, maxd);
            for (int i=0; i<m; i++)
                num+=pow(2, chance[i].first);
            cout<<"0.";
            num*=10;
            for (int i=0; i<8; i++)
            {
                int q=floor(num/denom);
                int x=num-q*denom;
                num=10*x;
                cout<<q;
            }
        }
        else
        {
            cout<<0.5;
        }
    }
    cout<<endl;
    return 0;
}

/*
15 4
2 3
4 5
6 7
8 9
10 11
12 13
14 15
-1
-1
-1
-1
-1
-1
-1
-1
*/
