#include <bits/stdc++.h>
#define MAXN 100003
#define endl '\n'
using namespace std;
typedef long long ll;
mt19937 randGenerator(878621611);

struct Treap
{
    int key;
    int priority, subtreeSize;
    int val;
    Treap *left, *right;
    Treap (int _key)
    {
        key = _key;
        priority = randGenerator();
        subtreeSize = 1;
        val = 1;
        left = nullptr;
        right = nullptr;
    }
    int find_kth(int k)
    {
        int leftSubtree = (left == nullptr ? 0 : left->subtreeSize);
        if (leftSubtree == k)
            return key;
        if (leftSubtree > k)
            return left->find_kth(k);
        else
            return right->find_kth(k - leftSubtree - 1);
    }
    void recalc()
    {
        subtreeSize = 1;
        subtreeSize += (left == nullptr ? 0 : left->subtreeSize);
        subtreeSize += (right == nullptr ? 0 : right->subtreeSize);
        val = 1;
        int leftSubtree = (left == nullptr ? 0 : left->subtreeSize);
        if (left != nullptr)
        {
            val += left->val;
            if (key == left->find_kth(leftSubtree - 1))
                --val;
        }
        if(right != nullptr)
        {
            val += right->val;
            if (key == right->find_kth(0))
                --val;
        }
    }
};

void print(Treap *t)
{
    if (t == nullptr)
        return;
    if (t->left != nullptr)
        print(t->left);
    if (t->right != nullptr)
        print(t->right);
}

Treap *merge(Treap *sm, Treap *bg)
{
    if (sm == nullptr)
        return bg;
    if (bg == nullptr)
        return sm;
    if (sm->priority > bg->priority)
    {
        sm->right = merge(sm->right, bg);
        sm->recalc();
        return sm;
    }
    else
    {
        bg->left = merge(sm, bg->left);
        bg->recalc();
        return bg;
    }
}

pair <Treap*, Treap*> split1(Treap *t, int k)
{
    if (t == nullptr)
        return {nullptr, nullptr};
    if (t->key > k)
    {
        auto splitResults = split1(t->left, k);
        t->left = splitResults.second;
        t->recalc();
        return {splitResults.first, t};
    }
    else
    {
        auto splitResults = split1(t->right, k);
        t->right = splitResults.first;
        t->recalc();
        return {t, splitResults.second};
    }
}

pair <Treap*, Treap*> split2(Treap *t, int sz)
{
    if (t == nullptr)
        return {nullptr, nullptr};
    int leftSubtree = (t->left == nullptr ? 0 : t->left->subtreeSize);
    if (leftSubtree >= sz)
    {
        auto splitResults = split2(t->left, sz);
        t->left = splitResults.second;
        t->recalc();
        return {splitResults.first, t};
    }
    else
    {
        auto splitResults = split2(t->right, sz - leftSubtree - 1);
        t->right = splitResults.first;
        t->recalc();
        return {t, splitResults.second};
    }
}

void heapify(Treap *t)
{
    if (t == nullptr)
        return;
    Treap *max = t;
    if (t->left != nullptr && t->left->priority > max->priority)
        max = t->left;
    if (t->right != nullptr && t->right->priority > max->priority)
        max = t->right;
    if (max != t)
    {
        swap(max->priority, t->priority);
        heapify(max);
    }
}

Treap *constr(int arr[], int n)
{
    if (n == 0)
        return nullptr;
    int mid = n / 2;
    Treap *t = new Treap(arr[mid]);
    t->left = constr(arr, mid);
    t->right = constr(arr + mid + 1, n - mid - 1);
    heapify(t);
    t->recalc();
    return t;
}

int n;
int clr[MAXN];
Treap *root;

void input()
{
    cin >> n;
    for (int i = 0; i < n; ++i)
        cin >> clr[i];
    root = constr(clr, n);
}

void q1(int k)
{
    auto splitResults1 = split2(root, k - 1);
    auto splitResults2 = split2(splitResults1.second, 1);
    root = merge(splitResults1.first, splitResults2.second);
}

void q2(int p, int c)
{
    Treap *t = new Treap(c);
    auto splitResults = split2(root, p);
    root = merge(splitResults.first, merge(t, splitResults.second));
}

void q3(int q, int s)
{
    Treap *t = new Treap(s);
    auto splitResults1 = split2(root, q);
    auto splitResults2 = split2(splitResults1.second, 1);
    root = merge(splitResults1.first, merge(t, splitResults2.second));
}

int q4()
{
    return root->val;
}

void calc()
{
    int t;
    cin >> t;
    for (int i = 0; i < t; ++i)
    {
        int type, x, y;
        cin >> type;
        if (type == 4)
        {
            cout << q4() << endl;
        }
        else if (type == 3)
        {
            cin >> x >> y;
            q3(x - 1, y);
        }
        else if (type == 2)
        {
            cin >> x >> y;
            q2(x - 1, y);
        }
        else
        {
            cin >> x;
            q1(x);
        }
    }
}

/**
10
2 3 3 1 1 4 5 1 1 3
8
1 6
3 6 1
4
1 1
2 2 1
4
2 9 2
4
*/

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    input();
    calc();

    return 0;
}
